#include <gtk/gtk.h>
#include <glib/gprintf.h>

enum {COL_ID=0, COL_VAL=1};
gchar* lst_lang[] = {"C", "C++", "JAVA", "RUST", "GO", "JS", "PHP","LISP","ADA","Autre"};

typedef struct{
  gint    id;
  gchar*  lang;
}DataLang;
  
typedef struct{
  GtkWidget *win;
  GtkWidget *vbox;
  GtkWidget *bt1;
  GtkWidget *label;
  GtkWidget *combo;
}WinData;
  
void on_get_value(GtkButton* btn, gpointer ptrUserData){
  WinData *uData = ptrUserData;
  GtkTreeIter  iter;
  GtkTreeModel* tmpLst;
  DataLang selectedData;

  tmpLst = gtk_combo_box_get_model (GTK_COMBO_BOX(uData->combo));
  
  gboolean is_active = gtk_combo_box_get_active_iter (GTK_COMBO_BOX(uData->combo), & iter);
  if(is_active){
    gtk_tree_model_get (tmpLst, &iter, COL_ID , &selectedData.id, COL_VAL, &selectedData.lang, -1);
    gchar print_data[20];
    g_snprintf(print_data, 20, "%i : %s", selectedData.id, selectedData.lang) ;
    gtk_label_set_text(GTK_LABEL(uData->label), print_data);
  }
}

int main(int argc, char* argv[]){
  WinData  wdata;
  gtk_init(&argc, &argv);

  /****************************
   * Création de la fenêtre
   ****************************/
  wdata.win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  g_signal_connect (G_OBJECT(wdata.win),"delete_event",G_CALLBACK(gtk_main_quit) ,NULL);
  gtk_container_set_border_width (GTK_CONTAINER (wdata.win), 10);
  wdata.vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 20);
  gtk_container_add(GTK_CONTAINER(wdata.win), wdata.vbox);

  wdata.label = gtk_label_new(" Aucune valeur ");
  gtk_box_pack_end(GTK_BOX(wdata.vbox),wdata.label, TRUE, TRUE, 0);
  wdata.bt1   = gtk_button_new_with_label("Choisir");
  g_signal_connect (G_OBJECT(wdata.bt1),"clicked",G_CALLBACK(on_get_value) ,&wdata);
  gtk_box_pack_end(GTK_BOX(wdata.vbox),wdata.bt1, TRUE, TRUE, 0);

  
  /***************************************
   * Création du modèle pour le combobox 
   ***************************************/
  GtkTreeIter iter;
  GtkListStore *lst = gtk_list_store_new(2, G_TYPE_INT, G_TYPE_STRING);
  
  for (gint i = 0; i< 10 ; i ++){
    DataLang dLang;
    dLang.id = i;
    dLang.lang = lst_lang[i];
    gtk_list_store_append (lst, &iter);
    gtk_list_store_set(lst, &iter, COL_ID, dLang.id , COL_VAL, dLang.lang, -1);
  }

  /************************
   * Création du combobox 
   ************************/
  //création du combo
  wdata.combo = gtk_combo_box_new_with_model(GTK_TREE_MODEL(lst));

  //création de la première colonne 

  // Pour afficher l'id il suffi de décommenter les lignes suvantes :
  /*
  GtkCellRenderer * rcell1 = NULL;
  rcell1 = gtk_cell_renderer_text_new ();
  gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (wdata.combo), rcell1, FALSE);
  gtk_cell_layout_set_attributes ( GTK_CELL_LAYOUT (wdata.combo), rcell1, "text", 0, NULL);
  */

  //création de la seconde colonne 
  GtkCellRenderer * rcell2 = NULL;
  rcell2 = gtk_cell_renderer_text_new ();
  gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (wdata.combo), rcell2, FALSE);
  gtk_cell_layout_set_attributes ( GTK_CELL_LAYOUT (wdata.combo), rcell2, "text", 1, NULL);

  //ajouter dans la vbox 
  gtk_box_pack_end(GTK_BOX(wdata.vbox),wdata.combo, TRUE, TRUE, 0);
  
  gtk_widget_show_all(wdata.win);
  gtk_main();
  return 0;
}
